#!/bin/bash +x

debug=0
if [ "x${1}" != "x" ]; then
  if [ ${1} == "-d" ]; then
    debug=1
  else if [ ${1} == "-dd" ]; then
    debug=1
    set -x
    shift
  fi
  fi
fi

indent=0
id_idx=0
simple=0
closing=0
while read -d \> a ; do 
#  echo ""
#  echo Original: ${a}

  # if we have a simple element don't change indent
  if echo $a | grep -q /\$ ; then
    if [[ ${debug} -eq 1 ]] ; then echo FOUND slash at end ; fi
    simple=1
  fi

  # not simple element, figure out new indent
  newline=1
  if [ ${simple} == 0 ]; then
    if [[ ${debug} -eq 1 ]]; then echo Read: ${a} ; fi
#    id=`echo ${a} | sed -e s/\<// | sed -e s/\ [-a-zA-Z0-9\.:\ \'\"_=@/]*//`
    if echo $a | grep -q \^\</ ; then
      closing=1
      if [[ ${debug} -eq 1 ]] ; then echo FOUND closing element ; fi
    else if echo $a | grep -q \</ ; then
      if [[ ${debug} -eq 1 ]] ; then echo FOUND item followed by closing element ; fi
      newline=0
      let indent=${indent}-2
    else
      if [[ ${debug} -eq 1 ]] ; then echo FOUND new element ; fi
      let indent=${indent}+2
      # we're not using the ID to determine matched pairs; we trust we get a well-formed XML
#      id[${id_idx}]=${id}
#      let id_idx=${id_idx}+1
#      echo ID Stored: ${id[$((${id_idx}-1))]}
    fi
    fi
  fi

  loop=${indent}
  if [ ${simple} == 1 ]; then 
    let loop=${loop}+2
  fi

  # this does the indentation and line breaks
  if [[ ${newline} -eq 1 ]]; then
    echo ""
    while [ ${loop} -gt 0 ]; do
      echo -n "  "
      let loop=${loop}-2
    done
  fi

  # print string now
  echo -n ${a}\>

  if [ ${closing} == 1 ]; then
    let indent=${indent}-2
  fi

  simple=0
  closing=0
done
